#include <bullet\LinearMath\btIDebugDraw.h>
#include "Shader.hpp"

#ifndef _camera_hpp_
#define _camera_hpp_
#include "../Scene/Camera.hpp"
#endif

namespace cgue {
	class DebugDrawer : public btIDebugDraw {
	public:
		DebugDrawer(Shader* shader, Camera* c);

		virtual void drawLine(const btVector3& from,const btVector3& to,const btVector3& color);

		virtual void drawContactPoint(const btVector3& PointOnB,const btVector3& normalOnB,btScalar distance,int lifeTime,const btVector3& color);
      
		virtual void reportErrorWarning(const char* warningString);
      
		virtual void draw3dText(const btVector3& location,const char* textString);
      
	    virtual void setDebugMode(int newDebugMode);
      
	    virtual int getDebugMode() const { return debugMode; }

		virtual void drawPoint(glm::vec3 p, glm::mat4 position);


	private:
		Shader* wireframeShader;
		Camera* camera;
		int debugMode;
		GLuint vao;
		GLuint vbo;

		float* points;
	};
}